package org.amse.im.practice.formula.impl;

import java.util.ArrayList;

import org.amse.im.practice.exceptions.MyException;
import org.amse.im.practice.formula.*;
import org.amse.im.practice.formula.syntaxTree.node.TreeBuilder;
import org.amse.im.practice.formula.syntaxTree.tokenType.IToken;
import org.amse.im.practice.formula.syntaxTree.tokenType.TokenType;

public class ConstantCountExpression implements IConstantExpression{
	private String myText;
	private double myValue;
	
	public ConstantCountExpression(String text) {
		myText = text;

		ArrayList<IToken> list = TreeBuilder.tokenize(text);
		for (IToken token : list) {
			if (token.getTypeOfToken() != TokenType.NUMBER){
				throw new MyException("string is not correct: ConstantCountExpression - not number");
			}	
		}		
		myValue = TreeBuilder.buildSyntaxTree(myText).evaluate(0, 0);
	}
	
	public String getText() {
		return myText;
	}
	
	public double value() {
		return myValue;
	}

}
