package org.amse.im.practice.formula.impl;

import java.util.ArrayList;

import org.amse.im.practice.exceptions.MyException;
import org.amse.im.practice.formula.*;
import org.amse.im.practice.formula.syntaxTree.node.*;
import org.amse.im.practice.formula.syntaxTree.tokenType.*;

public class ConstantExpression implements IConstantExpression {
	private String myText;
	private double myValue;
	
	public ConstantExpression(String text) {
		myText = text;

		ArrayList<IToken> list = TreeBuilder.tokenize(text);
		for (IToken token : list) {
			if (token.getTypeOfToken() == TokenType.VAR) {
				throw new MyException("string is not correct: ConstantExpression - var");
			}	
		}
		myValue = TreeBuilder.buildSyntaxTree(myText).evaluate(0, 0);
	}
	
	public String getText() {
		return myText;
	}
	
	public double value() {
		return myValue;
	}
}
