package org.amse.im.practice.formula.impl;

import org.amse.im.practice.exceptions.MyException;
import org.amse.im.practice.formula.*;
import org.amse.im.practice.formula.syntaxTree.node.INode;
import org.amse.im.practice.formula.syntaxTree.node.TreeBuilder;
import org.amse.im.practice.formula.syntaxTree.tokenType.IToken;
import org.amse.im.practice.formula.syntaxTree.tokenType.TokenFactory;

public class Expression implements IExpression {
	private String myText;
	private INode mySyntaxTree;
	
	public Expression(String text) {
		myText = text;
		mySyntaxTree = TreeBuilder.buildSyntaxTree(myText);
		}	
	
	public String getText() {
		return myText;
	}
	
	public double evaluate(double u, double t) {
		return mySyntaxTree.evaluate(u, t);
	}
}
