package org.amse.im.practice.test;

import org.amse.im.practice.formula.IFormula;
import org.amse.im.practice.formula.impl.Formula;

import junit.framework.TestCase;

public class FormulaEvaluateTest extends TestCase {

	public void test1(){
		String XFormula = "100 * sin(u) * cos(t)";
		String YFormula = "100 * cos(u) * cos(t)";
		String ZFormula = "100 * sin(t)";
		String StartU = "0";
		String StartT = "0";
		String EndU = "2 * pi";
		String EndT = "2 * pi";
		double u = 2;
		double t = 4;
				
		IFormula formula = new Formula(XFormula, YFormula, ZFormula,StartT, EndT, StartU, EndU);
		
		assertEquals(formula.evaluate(u, t).x, (100*Math.cos(t)*Math.sin(u)), 0.05);
		assertEquals(formula.evaluate(u, t).y, (100*Math.cos(t)*Math.cos(u)), 0.05);
		assertEquals(formula.evaluate(u, t).z, (100*Math.sin(t)), 0.05);
	}
	
	public void test2(){
		String XFormula = "(100 + 20 * sin(u)) * cos(t)";
		String YFormula = "(100 + 20 * sin(u)) * sin(t)";
		String ZFormula = "20 * cos(u)";
		String StartU = "0";
		String StartT = "0";
		String EndU = "2 * pi";
		String EndT = "2 * pi";
		double u = 2;
		double t = 4;
				
		IFormula formula = new Formula(XFormula, YFormula, ZFormula,StartT, EndT, StartU, EndU);
		
		assertEquals(formula.evaluate(u, t).x, ((100 + 20*Math.sin(u))*Math.cos(t)), 0.05);
		assertEquals(formula.evaluate(u, t).y, ((100 + 20*Math.sin(u))*Math.sin(t)), 0.05);
		assertEquals(formula.evaluate(u, t).z, (20*Math.cos(u)), 0.05);
	}
	
	public void test3(){
		String XFormula = "u";
		String YFormula = "t";
		String ZFormula = "20";
		String StartU = "0";
		String StartT = "0";
		String EndU = "2 * pi";
		String EndT = "2 * pi";
		double u = 2;
		double t = 4;
				
		IFormula formula = new Formula(XFormula, YFormula, ZFormula,StartT, EndT, StartU, EndU);
		
		assertEquals(formula.evaluate(u, t).x, (u), 0.05);
		assertEquals(formula.evaluate(u, t).y, (t), 0.05);
		assertEquals(formula.evaluate(u, t).z, (20), 0.05);
	}
}










