package org.amse.im.practice.test;

import java.io.*;

import javax.swing.JTextField;

import org.amse.im.practice.formula.*;
import org.amse.im.practice.formula.impl.*;
import org.amse.im.practice.io.*;
import org.amse.im.practice.surface.*;
import org.amse.im.practice.surface.impl.*;

import junit.framework.*;

public class ReaderXMLTest extends TestCase {
	
	private void writeXMLFile(String fileName, String stringX, String stringY, String stringZ, String stringStartT,
			  String stringEndT, String stringStartU, String stringEndU, String stringCountU, String stringCountT) {
		try {
			FileOutputStream fileOutputStream = new FileOutputStream(fileName);
			IFormula formula = new Formula(stringX, stringY, stringZ, stringStartT, stringEndT, 
										   stringStartU, stringEndU);
			ISurface surface = new Surface(formula, stringCountU, stringCountT); 
			new XMLWriter().write(surface, fileOutputStream);
		} catch(Exception exception) {
			exception.printStackTrace();
		}
	}
	
	private boolean isCorrect() {
		String expectedStringX = "sin(u)".intern();
		String expectedStringY = "t".intern();
		String expectedStringZ = "u * u".intern();
		String expectedStringStartT = "0".intern();
		String expectedStringEndT = "0".intern();
		String expectedStringStartU = "-10".intern();
		String expectedStringEndU = "10".intern();
		String expectedCountU = "40".intern();
		String expectedCountT= "40".intern();
		
		final String fileName = "org\\tests\\" + "XMLwriter11.xml";
		writeXMLFile(fileName, expectedStringX, expectedStringY, expectedStringZ, 
				expectedStringStartT, expectedStringEndT, expectedStringStartU, expectedStringEndU, 
				     expectedCountU, expectedCountT);
		
		JTextField xFormula = new JTextField("1");
		JTextField yFormula = new JTextField("2");
		JTextField zFormula = new JTextField();
		JTextField startU = new JTextField();
		JTextField endU = new JTextField();
		JTextField startT = new JTextField();
		JTextField endT = new JTextField();
		JTextField countU = new JTextField();
		JTextField countT = new JTextField();
		
		try {
			FileInputStream stream = new FileInputStream(fileName);
			new XMLReader(stream, xFormula, yFormula, zFormula, startU, endU, startT, 
						  endT, countU, countT);
		} catch(Exception e) {
		}
		
		System.out.println("test " + xFormula.getText() + " " + expectedStringX);
		System.out.println("test " + yFormula.getText() + " " + expectedStringY); 
		System.out.println("test " + zFormula.getText() + " " + expectedStringZ); 
		
		return (
				(xFormula.getText().intern() == expectedStringX) &&
				(yFormula.getText().intern() == expectedStringY) &&
				(zFormula.getText().intern() == expectedStringZ) 
//				(startU.getText() == expectedStringStartU) &&
//				(endU.getText() == expectedStringEndU) &&
//				(startT.getText() == expectedStringStartT) &&
//				(endT.getText() == expectedStringEndT) &&
//				(countT.getText() == expectedCountT) &&
//				(countU.getText() == expectedCountU) 
			    );
	}

	public void test1() {
		assertTrue(isCorrect());
	}
}
