package org.amse.im.practice.test;

import java.util.*;

import org.amse.im.practice.formula.syntaxTree.node.*;
import org.amse.im.practice.formula.syntaxTree.tokenType.*;

import junit.framework.TestCase;

public class TokenizeTest2 extends TestCase {
	
	private String createActualString(String string){
		List<IToken> list = TreeBuilder.tokenize(string);
		StringBuffer sb = new StringBuffer();
		for (IToken token : list) {
			sb.append(token + " ");
		}
		sb.append("end");
		return sb.toString();	
	}
	
	public void test1(){
		String actual = createActualString("200*sin(u)*cos(t)");
		String expected = "200 * sin ( u ) * cos ( t ) end";
		assertEquals(expected, actual);
	}
	
	public void test2(){
		String actual = createActualString("100.0 ");
		String expected = "100.0 end";
		assertEquals(expected, actual);
	}
}
