package org.amse.im.practice.test;

import java.io.*;
import org.amse.im.practice.formula.*;
import org.amse.im.practice.formula.impl.*;
import org.amse.im.practice.io.*;
import org.amse.im.practice.surface.*;
import org.amse.im.practice.surface.impl.*;
import junit.framework.*;

public class WriterXMLTest extends TestCase {
	
	private void writeXMLFile(String fileName, String stringX, String stringY, String stringZ, String stringStartT,
			  String stringEndT, String stringStartU, String stringEndU, String stringCountU, String stringCountT) {
		try {
			FileOutputStream fileOutputStream = new FileOutputStream("org\\tests\\" + fileName);
			IFormula formula = new Formula(stringX, stringY, stringZ, stringStartT, stringEndT, 
										   stringStartU, stringEndU);
			ISurface surface = new Surface(formula, stringCountU, stringCountT); 
			new XMLWriter().write(surface, fileOutputStream);
		} catch(Exception exception) {
			exception.printStackTrace();
		}
	}
	
	public void test1(){
		writeXMLFile("XMLwriter1.xml", "sin(u)", "t", "u * u", "0", "2*pi", "-pi", "pi", "40", "40");
	}
	
	public void test2(){
		writeXMLFile("XMLwriter2.xml", "-1", "1", "4 * u", "-100", "100", "-100", "100", "20", "20");
	}
	
	public void test3(){
		writeXMLFile("XMLwriter3.xml", "100 * sin(u) * cos(t)", "100 * sin(u) * sin(t)", 
				    "100 * cos(u)", "0", "2 * pi", "0", "2 * pi", "40", "40");
	}
	
	public void test4(){
		writeXMLFile("XMLwriter4.xml", "", "", 
				    "100 * cos(u)", "0", "2 * pi", "0", "2 * pi", "40", "40");
	}
}








